# Generated by Django 2.2.11 on 2020-09-05 14:07

from django.db import migrations
from django.utils.text import slugify

from scipost.constants import SCIPOST_DISCIPLINES, SCIPOST_SUBJECT_AREAS


def populate(apps, schema_editor):
    Branch = apps.get_model('ontology', 'Branch')
    AcademicField = apps.get_model('ontology', 'AcademicField')
    Specialty = apps.get_model('ontology', 'Specialty')

    for d in SCIPOST_DISCIPLINES:
        slug = slugify(d[0], allow_unicode=True)
        order = Branch.objects.count() + 1
        branch, created = Branch.objects.get_or_create(
            name=d[0],
            slug=slug,
            order=order
        )
        for f in d[1]:
            f_order = AcademicField.objects.filter(branch=branch).count() + 1
            acad_field, created = AcademicField.objects.get_or_create(
                branch=branch,
                name=f[1],
                slug=f[0],
                order=f_order
            )
            for sa in SCIPOST_SUBJECT_AREAS:
                if sa[0] == f[1]:
                    for code, spec in sa[1]:
                        slug = slugify(code.replace(':', '-'))
                        s_order = Specialty.objects.filter(acad_field=acad_field).count() + 1
                        specialty, created = Specialty.objects.get_or_create(
                            acad_field=acad_field,
                            name=spec,
                            slug=slug,
                            order=s_order
                        )


class Migration(migrations.Migration):

    dependencies = [
        ('ontology', '0006_auto_20200905_1904'),
    ]

    operations = [
        migrations.RunPython(populate, reverse_code=migrations.RunPython.noop),
    ]
